:- dynamic program_preds/1.
:- dynamic program_pred/2.
:- dynamic ub_clause/2.
:- dynamic directive/1.
:- op(900,fy,not).

/* Sicstus version of builtin */

sp_builtin(G) :-
        predicate_property(G,built_in).


/* IO utilities */

sp_writeClause((H :- B)) :-
	canonical((H :- B)),
        write(H),
        write(' :-'),nl,
        writeqBody(B).

sp_writeRclause((H :- B)) :-
	canonical((H :- B)),
        write(H),
        write(' :-'),
        writeqRBody(B).

new_line :-
        nl,
        tab(6).

getchar(C) :-
        ttyget(Ch),
        name(C,[Ch]).

sp_ttyflush :-
	ttyflush.

sp_ttynl :-
	ttynl.

sp_length(X,N) :-
	length(X,N).

end_of_file(end_of_file).

ref_clause(G,B,N) :-
	clause(ub_clause(G,B),true,N).
re_read(F) :-
	home_dir(D),
	concatstring(D,F,Fullpath),
	compile(Fullpath).
my_reconsult(F) :-
	home_dir(D),
	concatstring(D,F,Fullpath),
	compile(Fullpath).

directive(dummy).

?- compile(
['~john/LP/APE/ape.pl','~john/LP/APE/utils.pl','~john/LP/APE/unfold_utils.pl',
    '~john/LP/APE/cleanup.pl',
    '~john/LP/APE/msv_detpath.pl','~john/LP/APE/sp_main.pl',
    '~john/LP/Types/tp_alpha_any.pl', '~john/LP/Types/ub_any.pl',
    '~john/LP/Types/is_any.pl','~john/LP/Types/subtype_any.pl',
%    '~john/LP/Types/tp_rul.pl', '~john/LP/Types/ub2.pl',
%    '~john/LP/Types/is2.pl','~john/LP/Types/subtype2.pl',
%    '~john/LP/Types/subtype_any.pl',
    '~john/LP/Types/dg3.pl',
    '~john/LP/APE/magic1.pl',
    '~john/LP/APE/reex_trans.pl',
    '~john/LP/APE/binary.pl',
    '~john/LP/APE/unf.pl',
    '~john/LP/Types/precision.pl',
    '~john/LP/Types/modelize.pl',
    '~john/LP/Types/rule2clause.pl',
    '~john/LP/APE/time.pl',
%    '~john/LP/APE/sounds.pl',
    '~john/LP/APE/sp_consult.pl']).

/*
?- ['~john/LP/APE/ape.pl','~john/LP/APE/utils.pl','~john/LP/APE/unfold_utils.pl',
    '~john/LP/APE/cleanup.pl',
    '~john/LP/APE/msv_detpath.pl','~john/LP/APE/sp_main.pl',
    '~john/LP/Types/tp_alpha_any.pl', '~john/LP/Types/ub_any.pl',
    '~john/LP/Types/is_any.pl','~john/LP/Types/subtype_any.pl',
%    '~john/LP/Types/tp_rul.pl', '~john/LP/Types/ub2.pl',
%    '~john/LP/Types/is2.pl','~john/LP/Types/subtype2.pl',
%    '~john/LP/Types/subtype_any.pl',
    '~john/LP/Types/dg3.pl',
    '~john/LP/APE/magic1.pl',  
    '~john/LP/APE/reex_trans.pl',
    '~john/LP/APE/binary.pl',  
    '~john/LP/APE/unf.pl',
    '~john/LP/APE/time.pl',
    '~john/LP/Types/precision.pl',
    '~john/LP/Types/modelize.pl',
    '~john/LP/Types/rule2clause.pl',
%    '~john/LP/APE/sounds.pl',
    '~john/LP/APE/sp_consult.pl'].
*/
