%:- setdebug.
:- dynamic user_proc/3.

makeprocs :-
	program_preds(Ps),
	make_each_proc(Ps).

make_each_proc([]).
make_each_proc([P/N|Ps]) :-
	user_cls(P/N,Cls),
	assert((user_proc(P,N,W) :- W=Cls)),
	!,
	make_each_proc(Ps).

user_cls(P/N,Cls) :-
        functor(H,P,N),
        bagof((H:-B),ub_clause(H,B),Cls),
       !.
user_cls(_,[]).

% user_proc(P,N,Cls) :-
% 	user_cls(P/N,Cls).
